// Generated by gencpp from file view_controller_msgs/CameraMovement.msg
// DO NOT EDIT!


#ifndef VIEW_CONTROLLER_MSGS_MESSAGE_CAMERAMOVEMENT_H
#define VIEW_CONTROLLER_MSGS_MESSAGE_CAMERAMOVEMENT_H


#include <string>
#include <vector>
#include <memory>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <geometry_msgs/PointStamped.h>
#include <geometry_msgs/PointStamped.h>
#include <geometry_msgs/Vector3Stamped.h>

namespace view_controller_msgs
{
template <class ContainerAllocator>
struct CameraMovement_
{
  typedef CameraMovement_<ContainerAllocator> Type;

  CameraMovement_()
    : eye()
    , focus()
    , up()
    , transition_duration()
    , interpolation_speed(0)  {
    }
  CameraMovement_(const ContainerAllocator& _alloc)
    : eye(_alloc)
    , focus(_alloc)
    , up(_alloc)
    , transition_duration()
    , interpolation_speed(0)  {
  (void)_alloc;
    }



   typedef  ::geometry_msgs::PointStamped_<ContainerAllocator>  _eye_type;
  _eye_type eye;

   typedef  ::geometry_msgs::PointStamped_<ContainerAllocator>  _focus_type;
  _focus_type focus;

   typedef  ::geometry_msgs::Vector3Stamped_<ContainerAllocator>  _up_type;
  _up_type up;

   typedef ros::Duration _transition_duration_type;
  _transition_duration_type transition_duration;

   typedef uint8_t _interpolation_speed_type;
  _interpolation_speed_type interpolation_speed;



// reducing the odds to have name collisions with Windows.h 
#if defined(_WIN32) && defined(RISING)
  #undef RISING
#endif
#if defined(_WIN32) && defined(DECLINING)
  #undef DECLINING
#endif
#if defined(_WIN32) && defined(FULL)
  #undef FULL
#endif
#if defined(_WIN32) && defined(WAVE)
  #undef WAVE
#endif

  enum {
    RISING = 0u,
    DECLINING = 1u,
    FULL = 2u,
    WAVE = 3u,
  };


  typedef boost::shared_ptr< ::view_controller_msgs::CameraMovement_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::view_controller_msgs::CameraMovement_<ContainerAllocator> const> ConstPtr;

}; // struct CameraMovement_

typedef ::view_controller_msgs::CameraMovement_<std::allocator<void> > CameraMovement;

typedef boost::shared_ptr< ::view_controller_msgs::CameraMovement > CameraMovementPtr;
typedef boost::shared_ptr< ::view_controller_msgs::CameraMovement const> CameraMovementConstPtr;

// constants requiring out of line definition

   

   

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::view_controller_msgs::CameraMovement_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::view_controller_msgs::CameraMovement_<ContainerAllocator> >::stream(s, "", v);
return s;
}


template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator==(const ::view_controller_msgs::CameraMovement_<ContainerAllocator1> & lhs, const ::view_controller_msgs::CameraMovement_<ContainerAllocator2> & rhs)
{
  return lhs.eye == rhs.eye &&
    lhs.focus == rhs.focus &&
    lhs.up == rhs.up &&
    lhs.transition_duration == rhs.transition_duration &&
    lhs.interpolation_speed == rhs.interpolation_speed;
}

template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator!=(const ::view_controller_msgs::CameraMovement_<ContainerAllocator1> & lhs, const ::view_controller_msgs::CameraMovement_<ContainerAllocator2> & rhs)
{
  return !(lhs == rhs);
}


} // namespace view_controller_msgs

namespace ros
{
namespace message_traits
{





template <class ContainerAllocator>
struct IsFixedSize< ::view_controller_msgs::CameraMovement_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::view_controller_msgs::CameraMovement_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::view_controller_msgs::CameraMovement_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::view_controller_msgs::CameraMovement_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::view_controller_msgs::CameraMovement_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::view_controller_msgs::CameraMovement_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::view_controller_msgs::CameraMovement_<ContainerAllocator> >
{
  static const char* value()
  {
    return "fc7aac4a39426fb5e8b2dbb6e85bfc66";
  }

  static const char* value(const ::view_controller_msgs::CameraMovement_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xfc7aac4a39426fb5ULL;
  static const uint64_t static_value2 = 0xe8b2dbb6e85bfc66ULL;
};

template<class ContainerAllocator>
struct DataType< ::view_controller_msgs::CameraMovement_<ContainerAllocator> >
{
  static const char* value()
  {
    return "view_controller_msgs/CameraMovement";
  }

  static const char* value(const ::view_controller_msgs::CameraMovement_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::view_controller_msgs::CameraMovement_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# This message defines where to move a camera to and at which speeds.  \n"
"\n"
"# The target pose definition:\n"
"\n"
"# The frame-relative point to move the camera to.\n"
"geometry_msgs/PointStamped eye\n"
"\n"
"# The frame-relative point for the focus (or pivot for an Orbit controller).\n"
"# The camera points into the direction of the focus point at the end of the movement.\n"
"geometry_msgs/PointStamped focus\n"
"\n"
"# The frame-relative vector that maps to \"up\" in the view plane.\n"
"# In other words, a vector pointing to the top of the camera, in case you want to perform roll movements.\n"
"geometry_msgs/Vector3Stamped up\n"
"\n"
"\n"
"# Defines how long the transition from the current to the target camera pose should take.\n"
"# Movements with a negative transition_duration will be ignored.\n"
"duration transition_duration\n"
"\n"
"# The interpolation speed profile to use during this movement.\n"
"uint8 interpolation_speed\n"
"uint8 RISING    = 0 # Speed of the camera rises smoothly - resembles the first quarter of a sinus wave.\n"
"uint8 DECLINING = 1 # Speed of the camera declines smoothly - resembles the second quarter of a sinus wave.\n"
"uint8 FULL      = 2 # Camera is always at full speed - depending on transition_duration.\n"
"uint8 WAVE      = 3 # RISING and DECLINING concatenated in one movement.\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/PointStamped\n"
"# This represents a Point with reference coordinate frame and timestamp\n"
"Header header\n"
"Point point\n"
"\n"
"================================================================================\n"
"MSG: std_msgs/Header\n"
"# Standard metadata for higher-level stamped data types.\n"
"# This is generally used to communicate timestamped data \n"
"# in a particular coordinate frame.\n"
"# \n"
"# sequence ID: consecutively increasing ID \n"
"uint32 seq\n"
"#Two-integer timestamp that is expressed as:\n"
"# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')\n"
"# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')\n"
"# time-handling sugar is provided by the client library\n"
"time stamp\n"
"#Frame this data is associated with\n"
"string frame_id\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/Point\n"
"# This contains the position of a point in free space\n"
"float64 x\n"
"float64 y\n"
"float64 z\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/Vector3Stamped\n"
"# This represents a Vector3 with reference coordinate frame and timestamp\n"
"Header header\n"
"Vector3 vector\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/Vector3\n"
"# This represents a vector in free space. \n"
"# It is only meant to represent a direction. Therefore, it does not\n"
"# make sense to apply a translation to it (e.g., when applying a \n"
"# generic rigid transformation to a Vector3, tf2 will only apply the\n"
"# rotation). If you want your data to be translatable too, use the\n"
"# geometry_msgs/Point message instead.\n"
"\n"
"float64 x\n"
"float64 y\n"
"float64 z\n"
;
  }

  static const char* value(const ::view_controller_msgs::CameraMovement_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::view_controller_msgs::CameraMovement_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.eye);
      stream.next(m.focus);
      stream.next(m.up);
      stream.next(m.transition_duration);
      stream.next(m.interpolation_speed);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct CameraMovement_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::view_controller_msgs::CameraMovement_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::view_controller_msgs::CameraMovement_<ContainerAllocator>& v)
  {
    s << indent << "eye: ";
    s << std::endl;
    Printer< ::geometry_msgs::PointStamped_<ContainerAllocator> >::stream(s, indent + "  ", v.eye);
    s << indent << "focus: ";
    s << std::endl;
    Printer< ::geometry_msgs::PointStamped_<ContainerAllocator> >::stream(s, indent + "  ", v.focus);
    s << indent << "up: ";
    s << std::endl;
    Printer< ::geometry_msgs::Vector3Stamped_<ContainerAllocator> >::stream(s, indent + "  ", v.up);
    s << indent << "transition_duration: ";
    Printer<ros::Duration>::stream(s, indent + "  ", v.transition_duration);
    s << indent << "interpolation_speed: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.interpolation_speed);
  }
};

} // namespace message_operations
} // namespace ros

#endif // VIEW_CONTROLLER_MSGS_MESSAGE_CAMERAMOVEMENT_H
