# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from view_controller_msgs/CameraMovement.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy
import geometry_msgs.msg
import std_msgs.msg

class CameraMovement(genpy.Message):
  _md5sum = "fc7aac4a39426fb5e8b2dbb6e85bfc66"
  _type = "view_controller_msgs/CameraMovement"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# This message defines where to move a camera to and at which speeds.  

# The target pose definition:

# The frame-relative point to move the camera to.
geometry_msgs/PointStamped eye

# The frame-relative point for the focus (or pivot for an Orbit controller).
# The camera points into the direction of the focus point at the end of the movement.
geometry_msgs/PointStamped focus

# The frame-relative vector that maps to "up" in the view plane.
# In other words, a vector pointing to the top of the camera, in case you want to perform roll movements.
geometry_msgs/Vector3Stamped up


# Defines how long the transition from the current to the target camera pose should take.
# Movements with a negative transition_duration will be ignored.
duration transition_duration

# The interpolation speed profile to use during this movement.
uint8 interpolation_speed
uint8 RISING    = 0 # Speed of the camera rises smoothly - resembles the first quarter of a sinus wave.
uint8 DECLINING = 1 # Speed of the camera declines smoothly - resembles the second quarter of a sinus wave.
uint8 FULL      = 2 # Camera is always at full speed - depending on transition_duration.
uint8 WAVE      = 3 # RISING and DECLINING concatenated in one movement.

================================================================================
MSG: geometry_msgs/PointStamped
# This represents a Point with reference coordinate frame and timestamp
Header header
Point point

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Vector3Stamped
# This represents a Vector3 with reference coordinate frame and timestamp
Header header
Vector3 vector

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z"""
  # Pseudo-constants
  RISING = 0
  DECLINING = 1
  FULL = 2
  WAVE = 3

  __slots__ = ['eye','focus','up','transition_duration','interpolation_speed']
  _slot_types = ['geometry_msgs/PointStamped','geometry_msgs/PointStamped','geometry_msgs/Vector3Stamped','duration','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       eye,focus,up,transition_duration,interpolation_speed

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(CameraMovement, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.eye is None:
        self.eye = geometry_msgs.msg.PointStamped()
      if self.focus is None:
        self.focus = geometry_msgs.msg.PointStamped()
      if self.up is None:
        self.up = geometry_msgs.msg.Vector3Stamped()
      if self.transition_duration is None:
        self.transition_duration = genpy.Duration()
      if self.interpolation_speed is None:
        self.interpolation_speed = 0
    else:
      self.eye = geometry_msgs.msg.PointStamped()
      self.focus = geometry_msgs.msg.PointStamped()
      self.up = geometry_msgs.msg.Vector3Stamped()
      self.transition_duration = genpy.Duration()
      self.interpolation_speed = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.eye.header.seq, _x.eye.header.stamp.secs, _x.eye.header.stamp.nsecs))
      _x = self.eye.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3d3I().pack(_x.eye.point.x, _x.eye.point.y, _x.eye.point.z, _x.focus.header.seq, _x.focus.header.stamp.secs, _x.focus.header.stamp.nsecs))
      _x = self.focus.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3d3I().pack(_x.focus.point.x, _x.focus.point.y, _x.focus.point.z, _x.up.header.seq, _x.up.header.stamp.secs, _x.up.header.stamp.nsecs))
      _x = self.up.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3d2iB().pack(_x.up.vector.x, _x.up.vector.y, _x.up.vector.z, _x.transition_duration.secs, _x.transition_duration.nsecs, _x.interpolation_speed))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.eye is None:
        self.eye = geometry_msgs.msg.PointStamped()
      if self.focus is None:
        self.focus = geometry_msgs.msg.PointStamped()
      if self.up is None:
        self.up = geometry_msgs.msg.Vector3Stamped()
      if self.transition_duration is None:
        self.transition_duration = genpy.Duration()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.eye.header.seq, _x.eye.header.stamp.secs, _x.eye.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.eye.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.eye.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.eye.point.x, _x.eye.point.y, _x.eye.point.z, _x.focus.header.seq, _x.focus.header.stamp.secs, _x.focus.header.stamp.nsecs,) = _get_struct_3d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.focus.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.focus.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.focus.point.x, _x.focus.point.y, _x.focus.point.z, _x.up.header.seq, _x.up.header.stamp.secs, _x.up.header.stamp.nsecs,) = _get_struct_3d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.up.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.up.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 33
      (_x.up.vector.x, _x.up.vector.y, _x.up.vector.z, _x.transition_duration.secs, _x.transition_duration.nsecs, _x.interpolation_speed,) = _get_struct_3d2iB().unpack(str[start:end])
      self.transition_duration.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.eye.header.seq, _x.eye.header.stamp.secs, _x.eye.header.stamp.nsecs))
      _x = self.eye.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3d3I().pack(_x.eye.point.x, _x.eye.point.y, _x.eye.point.z, _x.focus.header.seq, _x.focus.header.stamp.secs, _x.focus.header.stamp.nsecs))
      _x = self.focus.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3d3I().pack(_x.focus.point.x, _x.focus.point.y, _x.focus.point.z, _x.up.header.seq, _x.up.header.stamp.secs, _x.up.header.stamp.nsecs))
      _x = self.up.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3d2iB().pack(_x.up.vector.x, _x.up.vector.y, _x.up.vector.z, _x.transition_duration.secs, _x.transition_duration.nsecs, _x.interpolation_speed))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.eye is None:
        self.eye = geometry_msgs.msg.PointStamped()
      if self.focus is None:
        self.focus = geometry_msgs.msg.PointStamped()
      if self.up is None:
        self.up = geometry_msgs.msg.Vector3Stamped()
      if self.transition_duration is None:
        self.transition_duration = genpy.Duration()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.eye.header.seq, _x.eye.header.stamp.secs, _x.eye.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.eye.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.eye.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.eye.point.x, _x.eye.point.y, _x.eye.point.z, _x.focus.header.seq, _x.focus.header.stamp.secs, _x.focus.header.stamp.nsecs,) = _get_struct_3d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.focus.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.focus.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.focus.point.x, _x.focus.point.y, _x.focus.point.z, _x.up.header.seq, _x.up.header.stamp.secs, _x.up.header.stamp.nsecs,) = _get_struct_3d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.up.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.up.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 33
      (_x.up.vector.x, _x.up.vector.y, _x.up.vector.z, _x.transition_duration.secs, _x.transition_duration.nsecs, _x.interpolation_speed,) = _get_struct_3d2iB().unpack(str[start:end])
      self.transition_duration.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_3d2iB = None
def _get_struct_3d2iB():
    global _struct_3d2iB
    if _struct_3d2iB is None:
        _struct_3d2iB = struct.Struct("<3d2iB")
    return _struct_3d2iB
_struct_3d3I = None
def _get_struct_3d3I():
    global _struct_3d3I
    if _struct_3d3I is None:
        _struct_3d3I = struct.Struct("<3d3I")
    return _struct_3d3I
